
{ Traduction en Pascal du dmineur en C de "CGi" :
  http://chgi.developpez.com/wincode/demineur/
  Compilation teste : Delphi 7, Free Pascal 2.6.4, Virtual Pascal 2.1.
}

program Mines;

{$IFDEF VPASCAL}
  {$PMTYPE PM}
  {$H+}
{$ELSE}
  {$APPTYPE GUI}
  {$IFDEF FPC}
    {$MODE DELPHI}
  {$ENDIF}
  {$WARN SYMBOL_PLATFORM OFF}
{$ENDIF}

uses
  Messages, Windows, SysUtils;

{$R MINES.RES}

const
  LARGEUR      = 32;
  COLONNES     =  8;
  LIGNES       =  8;
  NOMBRE_MINES =  8;

  IDM_QUIT  = 101;
  IDM_NEW   = 102;
  IDM_ABOUT = 103;
  
  VAL_MINE   = $00000100;
  VAL_VOILE  = $00010000;
  VAL_REVELE = $FFFEFFFF;
  VAL_NOMBRE = $0000000F;

type
  tTableau = array[0..LIGNES - 1, 0..COLONNES - 1]of integer;

var
  hFenetre: HWND;
  hMenu, hSousMenu: tHandle;
  tableau: tTableau;
  fin: boolean;

function Demine(var aTableau: tTableau; const y, x: integer): boolean;
var
  void: boolean;
begin
  if (aTableau[y, x] and VAL_VOILE) > 0 then
    aTableau[y, x] := aTableau[y, x] and VAL_REVELE
  else
  begin
    Result := FALSE;
    exit;
  end;
  if (aTableau[y, x] and VAL_MINE) > 0 then
  begin
    Result := TRUE;
    exit;
  end;
  if (aTableau[y, x] and VAL_NOMBRE) > 0 then
  begin
    Result := FALSE;
    exit;
  end;
  if (y > 0) and (x > 0) then
    void := Demine(aTableau, y - 1, x - 1);
  if (y > 0) then
    void := Demine(aTableau, y - 1, x);
  if (y > 0) and (x < COLONNES - 1) then
    void := Demine(aTableau, y - 1, x + 1);
  if (x > 0) then
    void := Demine(aTableau, y, x - 1);
  if (x < COLONNES - 1) then
    void := Demine(aTableau, y, x + 1);
  if (y < LIGNES - 1) and (x > 0) then
    void := Demine(aTableau, y + 1, x - 1);
  if (y < LIGNES - 1) then
    void := Demine(aTableau, y + 1, x);
  if (y < LIGNES - 1) and (x < COLONNES - 1) then
    void := Demine(aTableau, y + 1, x + 1);
  Result := FALSE;
end;

procedure Montre(var aTableau: tTableau);
var
  x, y: integer;
begin
  for y := 0 to  LIGNES - 1 do
    for x := 0 to COLONNES - 1 do
      aTableau[y, x] := aTableau[y, x] and VAL_REVELE;
end;

function Verifie(const aTableau: tTableau): boolean;
var
  x, y: integer;
begin
  Result := TRUE;
  for y := 0 to LIGNES - 1 do
    for x := 0 to COLONNES - 1 do
      if ((aTableau[y, x] and VAL_VOILE) > 0) and
         ((aTableau[y, x] and VAL_MINE) = 0) then
           Result := FALSE;
end;

procedure Initialise(var aTableau: tTableau);
var
  x, y: integer;
  xMine, yMine: integer;
begin
  for y := 0 to LIGNES - 1 do
    for x := 0 to COLONNES - 1 do
      aTableau[y, x] := 0;
  x := 0;
  while x < NOMBRE_MINES do
  begin
    xMine := Random(COLONNES);
    yMine := Random(LIGNES);
    if (aTableau[yMine, xMine] and VAL_MINE) = 0 then
    begin
      aTableau[yMine, xMine] := VAL_MINE;
      Inc(x);
    end;
  end;
  for y := 0 to LIGNES - 1 do
    for x := 0 to COLONNES - 1 do
    begin
      if (aTableau[y, x] and VAL_MINE) > 0 then
      begin
        if (y > 0) and (x > 0) then
          Inc(aTableau[y - 1, x - 1]);
        if (y > 0) then
          Inc(aTableau[y - 1, x]);
        if (y > 0) and (x < COLONNES - 1) then
          Inc(aTableau[y - 1, x + 1]);
        if (x > 0) then
          Inc(aTableau[y, x - 1]);
        if (x < COLONNES - 1) then
          Inc(aTableau[y, x + 1]);
        if (y < LIGNES - 1) and (x > 0) then
          Inc(aTableau[y + 1, x - 1]);
        if (y < LIGNES - 1) then
          Inc(aTableau[y + 1, x]);
        if (y < LIGNES - 1) and (x < COLONNES - 1) then
          Inc(aTableau[y + 1, x + 1]);
      end;
      aTableau[y, x] := aTableau[y, x] or VAL_VOILE;
    end;
  fin := FALSE;
end;

function WndProc(hWnd: HWND; msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  x, y, xMouse, yMouse: integer;
  oldPen, newPen: HPEN;
  DC, auxDC: HDC;
  hBmp: HBITMAP;
  ps: tPaintStruct;
  r1, r2: tRect;
  hBsh: HBRUSH;
  s: string;
begin
  case msg of
    WM_CREATE:
      begin
        Randomize;
        Initialise(tableau);
        Result := 0;
        exit;
      end;
    WM_COMMAND:
      case LoWord(wParam) of
        IDM_QUIT: PostMessage(hWnd, WM_CLOSE, 0, 0);
        IDM_NEW:
          begin
            Initialise(tableau);
            InvalidateRect(hWnd, nil, FALSE);
          end;
        IDM_ABOUT: MessageBox(0, 'Dmineur par CGi.'#10'Version Pascal par Roland Chastain.', 'Mines', MB_OK);
      end;
    WM_LBUTTONUP:
      begin
        xMouse := LoWord(lParam);
        yMouse := HiWord(lParam);
        x := xMouse div LARGEUR;
        y := yMouse div LARGEUR;
        InvalidateRect(hWnd, nil, FALSE);
        if fin then
        begin
          Result := 0;
          exit;
        end;
        if Demine(tableau, y, x) then
        begin
          Montre(tableau);
          MessageBox(0, 'Vous avez perdu !', 'Mines', MB_OK);
          fin := TRUE;
        end else
          if Verifie(tableau) then
          begin
            MessageBox(0, 'Vous avez gagn !', 'Mines', MB_OK);
            fin := TRUE;
          end;
        Result := 0;
        exit;
      end;
    WM_KEYDOWN:
      begin
        if wParam = VK_ESCAPE then
        begin
          PostQuitMessage(0);
          Result := 0;
          Exit;
        end;
      end;
    WM_DESTROY:
      begin
        PostQuitMessage(0);
        Result := 0;
        Exit;
      end;
    WM_PAINT:
    begin
      hBsh := CreateSolidBrush($D0D0D0);
      newPen := CreatePen(PS_SOLID, 1, $303030);
      GetClientRect(hWnd, r1);
      DC := BeginPaint(hFenetre, ps);

      auxDC := CreateCompatibleDC(DC);
      hBmp := CreateCompatibleBitmap(DC, r1.right, r1.bottom);
      SelectObject(auxDC, hBmp);
      oldPen := SelectObject(auxDC, newPen);

      FillRect(auxDC, r1, CreateSolidBrush($C0C0C0));

      for y := 0 to LIGNES - 1 do
        for x := 0 to COLONNES - 1 do
        begin
          r2.left := x * LARGEUR + 1;
          r2.right := x * LARGEUR + LARGEUR;
          r2.top := y * LARGEUR + 1;
          r2.bottom := y * LARGEUR + LARGEUR;

          Rectangle
          (
            auxDC,
            r2.left,
            r2.top,
            r2.right,
            r2.bottom
          );
          
          SetTextColor(auxDC, 0);
          if (tableau[y, x] and VAL_MINE) > 0 then
            DrawText(auxDC, 'M', 1, r2, DT_CENTER or DT_VCENTER or DT_SINGLELINE);

          if (tableau[y, x] > 0) and (tableau[y, x] < 9) then
          begin
            Str(tableau[y, x], s);
            case tableau[y, x] of
              1: SetTextColor(auxDC, $FF0000);
              2: SetTextColor(auxDC, $008F00);
              3: SetTextColor(auxDC, $0000FF);
            else SetTextColor(auxDC, $FF00FF);
            end;
            DrawText(auxDC, pChar(s), 1, r2, DT_CENTER or DT_VCENTER or DT_SINGLELINE);
          end;
          
          if (tableau[y, x] and VAL_VOILE) > 0 then
          begin
            Inc(r2.left);
            Dec(r2.right);
            Inc(r2.top);
            Dec(r2.bottom);
            FillRect(auxDC, r2, hBsh);
          end;

        end;
      
      BitBlt(DC, 0, 0, r1.right, r1.bottom, auxDC, 0, 0, SRCCOPY);

      DeleteDC(auxDC);
      DeleteObject(hBmp);
      EndPaint(hFenetre, ps);
      DeleteObject(hBsh);
      SelectObject(DC, oldPen);
      DeleteObject(newPen);
      Result := 0;
      Exit;
    end;
  end;
  Result := DefWindowProc(hWnd, msg, wParam, lParam);
end;

procedure ClientResize(aHandle: HWND; aWidth, aHeight: integer);
var
  cr, wr: TRect;
  d: TPoint;
begin
  GetClientRect(aHandle, cr);
  GetWindowRect(aHandle, wr);
  d.x := (wr.right - wr.left) - cr.right;
  d.y := (wr.bottom - wr.top) - cr.bottom;
  MoveWindow(aHandle, wr.left, wr.top, aWidth + d.x, aHeight + d.y, true);
end;

const
  APPNAME = 'Mines';

var
  wc: tWndClass;
  msg: tMsg;
  //r: tRect;
  //w, h: integer;
  //s: string;
  
begin
  Randomize;
  
  wc.Style := CS_VREDRAW or CS_HREDRAW;
  wc.lpfnWndProc := @WndProc;
  wc.cbClsExtra := 0;
  wc.cbWndExtra := 0;
  wc.hInstance := hInstance;
  wc.hIcon := LoadIcon(hInstance, MakeIntResource(1));
  wc.hCursor := LoadCursor({hInstance}0, IDC_ARROW);
  wc.hbrBackground := CreateSolidBrush($C0C0C0);
  wc.lpszMenuName := nil;
  wc.lpszClassName:= APPNAME;
  RegisterClass(wc);
  
  hSousMenu := CreateMenu;
  AppendMenu(hSousMenu, MF_STRING, IDM_NEW, 'Nouvelle Partie');
  AppendMenu(hSousMenu, MF_STRING, IDM_ABOUT, 'A Propos');
  AppendMenu(hSousMenu, MF_STRING, IDM_QUIT, 'Quitter');
  hMenu := CreateMenu;
  AppendMenu(hMenu, MF_POPUP, hSousMenu, 'Fichier');
  
  hFenetre := CreateWindow
  (
    APPNAME,
    'Mines',
    WS_SYSMENU or WS_CAPTION or WS_MINIMIZEBOX,
    integer(CW_USEDEFAULT),
    integer(CW_USEDEFAULT),
    LARGEUR * COLONNES + 1 + 2 * GetSystemMetrics(sm_CXFrame),
    LARGEUR * LIGNES + 1 + GetSystemMetrics(sm_CYCaption) + GetSystemMetrics(sm_CYMenu) + 2 * GetSystemMetrics(sm_CYFrame),
    0,
    hMenu,
    HInstance,
    nil
  );
  ShowWindow(hFenetre, CMDSHOW);
  UpdateWindow(hFenetre);
  
  ClientResize(hFenetre, LARGEUR * COLONNES + 1, LARGEUR * LIGNES + 1);
  
  while msg.message <> WM_QUIT do
  begin
    if PeekMessage(msg, 0, 0, 0, PM_REMOVE) then
    begin
      TranslateMessage(msg);
      DispatchMessage(msg);
    end;
  end;
  ExitProcess(msg.wParam);
end.
